######################
###                ###
###   Exercise 2   ###
###                ###
######################
	### Tokenizing text using regular expressions. 
	### Obtain some plain text data (e.g. visit a web-page and save it as plain text), 
	### and store it in a file 'corpus.txt' so that you can answer the following questions.


##########################
###   Exercise 2 (a)   ###
##########################
	### Word processors typically hyphenate words when they are split across a linebreak. 
	### When word-processed documents are converted to plain text, the pieces are usually not recombined. 
	### It is easy to discover such texts by searching on the web for broken words, e.g. depart- ment. 
	### Create a RegexpTokenizer which treats such broken words as a single token. 
print '\n(2a) Tokenizer that copes with hyphenated words:'
text_str = open('C:\\nakov\\courses_fall_04\\SIMS_290-2\\assignment1\\corpus2.txt').read()
print text_str

from nltk.tokenizer import *
text_token = Token(TEXT=text_str)
regexp = r'(\w+(\-\s*\w+)?)|(\$\d+\.\d+)|([^\w\s]+)'
tokenizer = RegexpTokenizer(regexp, SUBTOKENS='WORDS')
tokenizer.tokenize(text_token)
print text_token

print '\nNow, if we want to substitute:'
for tok in text_token['WORDS']:
    tok['TEXT']= re.sub('\s*-\s+', '', tok['TEXT'])
print text_token


##########################
###   Exercise 2 (b)   ###
##########################
	### Consider the following book title: This Is the Beat Generation: New York-San Francisco-Paris. 
	### What would it take to be able to tokenize such strings so that each city name was stored as a single token? 

print '\n(2b:1) Does not really work. Rather an illustration of the problems:'
text_token = Token(TEXT='This Is the Beat Generation: New York-San Francisco-Paris')
print text_token
regexp = r'(\w+\s\w+)|([^\w\s]+)|(\w+)'
tokenizer = RegexpTokenizer(regexp, SUBTOKENS='WORDS')
tokenizer.tokenize(text_token)
print text_token

print '\n(2b:2) Almost works, but overfits to the current example only:'
regexp = r'(\w+(\s\w+\-)?)'
tokenizer = RegexpTokenizer(regexp, SUBTOKENS='WORDS')
tokenizer.tokenize(text_token)
print text_token

print '\n(2b:3) Uses lexicalized rules:'
import string
wordr = r'(\w+)'
punct = r'([^\w\s]+)'
city = r'((New|San)+\s\w+)'
regexp = string.join([punct,city,wordr],"|")
tokenizer = RegexpTokenizer(regexp, SUBTOKENS='WORDS')
tokenizer.tokenize(text_token)
print text_token
