######################
###                ###
###   Exercise 3   ###
###                ###
######################
	### Working with tagged text. Write a program which loads the Brown corpus, then, given a word, 
	### lists the possible tags for the word each with a frequency count. For example, for the word 
	### strike the program would generate: [('nn', 25), ('vb', 21)]. (Hint: this task involves sorting 
	### and reversing a list of tuples which has the form [(21, 'vb'), (25, 'nn')]. To convert such 
	### lists into the required form, use word_freq = [(y,x) for (x,y) in freq_word].) 
from nltk.corpus import brown
from nltk.probability import ConditionalFreqDist
cfdist = ConditionalFreqDist()
for item in brown.items():
	text_token = brown.read(item)
	for token in text_token['WORDS']:
		tag = token['TAG']
		lowerToken = token['TEXT'].lower()	# normalize the word (i.e. convert to LOWERCASE!)
		cfdist[lowerToken].inc(tag)

def getPOSdistr(word):
	distr = []
	for POStag in cfdist[word].sorted_samples():
		distr.append((POStag, cfdist[word].count(POStag)))
	return distr

print '\n(3) Getting the frequency distribution for the word \'strike\':'
print 'cfdist[\'strike\']:', cfdist['strike']
print 'getPOSdistr(\'strike\'):', getPOSdistr('strike')

def getPOSdistrProb(word):
	return [(i, cfdist[word].freq(i)) for i in cfdist[word].sorted_samples()]

def getPOSdistrCount(word):
	return [(i, cfdist[word].count(i)) for i in cfdist[word].sorted_samples()]

print 'getPOSdistrCount(\'strike\'):', getPOSdistrCount('strike')

print '\n(3) Getting the probability distribution for the word \'strike\':'
print 'getPOSdistrFreq(\'strike\'):', getPOSdistrFreq('strike')


##########################
###   Exercise 3 (a)   ###
##########################
	### Use your program to print the tags and their frequencies for the following words: 
	### can, fox, get, lift, like, but, frank, line, interest. Check that you know the meaning of the high-frequency tags. 
words = ['can', 'fox', 'get', 'lift', 'like', 'but', 'frank', 'line', 'interest']
print '\n(3a) Getting the frequency distribution of the words: ', words
for word in words:
	print "%10s --> " % word, getPOSdistr(word)
	

##########################
###   Exercise 3 (b)   ###
##########################
	### Write a program to find the 20 words which have the greatest variety of different possible tags. 
wordTagFreqs = []
for word in cfdist.conditions():
	wordTagFreqs.append( (cfdist[word].B(), word) )
wordTagFreqs.sort()
wordTagFreqs.reverse()
print '\n(3b) The 20 words which have the greatest variety of different possible tags: '
print wordTagFreqs[:20]


##########################
###   Exercise 3 (c)   ###
##########################
	### Pick words which can be either a noun or a verb (e.g. deal). 
	### Guess which is the most likely tag for each word, then check whether you were right. 

words = ['check', 'code', 'deal', 'fly', 'form', 'guess', 'head', 'interest', 'list', 'measure', 'note', 'saw', 'tag', 'trace', 'use']
print '\n(3c) Words that can be either a noun or a verb: ', words
for word in words:
	print "%10s --> " % word, getPOSdistr(word)
