######################
###                ###
###   Exercise 2   ###
###                ###
######################
	### Regular Expression Tagging. We defined the NN_CD_Tagger,
	### which can be used as a fall-back tagger for unknown words.
	### This tagger only checks for cardinal numbers. By testing
	### for particular prefix or suffix strings, it should be possible
	### to guess other tags. For example, we could tag any word
	### that ends with -s as a plural noun. 

### 1. Read Brown corpus
from nltk.corpus import brown
from nltk.tagger import *
brown_tokens = []
for item in brown.items()[:10]:    # texts 0-9
	brown_tokens.append(brown.read(item))

	
##########################
###   Exercise 2 (a)   ###
##########################
	### Define a RegexpTagger which tests for at least five other patterns
	### in the spelling of words. (Use inline documentation to explain the rules.) 
myRegexpTagger = RegexpTagger([(r'^[0-9]+(.[0-9]+)?$', 'cd'), (r',', ','), (r'\.', '\.'),\
							   (r'^[A-Z].*\'s$', 'np$'), (r'^[a-z].*\'s$', 'nn$'), (r'^.*ly$', 'rb'),\
							   (r'^.*al$', 'jj'), (r'^.*ful$', 'jj'), (r'^.*ous$', 'jj'),\
							   (r'^.*tion$', 'nn'), (r'^.*ing$', 'vbg'), (r'^.*ble$', 'jj'),\
							   (r'^.*ize$', 'vb'), (r'^.*ed$', 'vbn'), (r'^.*s$', 'nns'),\
							   (r'.*', 'nn')], SUBTOKENS='WORDS')

##########################
###   Exercise 2 (b)   ###
##########################
	### Evaluate the tagger using tagger_accuracy(), and discuss your findings. 
print '\n(2b) The tagger\'s accuracy is:', tagger_accuracy(myRegexpTagger, brown_tokens)

